<?php
/**
 * Filter to convert a favicon to PNG.
 *
 * This file contains the wp_favicons_convert filter implementation
 * to convert a favicon to PNG.
 *
 * Note: feel free to add your own filters!
 *
 * @package WP-Favicons
 * @since 0.4.0
 * @author Edward de Leau <e@leau.net>
 * @copyright Edward de Leau, http://edward.de.leau.net
 */

namespace leau\co\wp_favicons;

/**
 *
 * Enter description here ...
 * @package WP-Favicons
 * @param $favicon_array
 */
if (!class_exists("filters_convert_to_png"))
{
	class filters_convert_to_png extends Plugin
	{


		/**
		 * Converts an ico to png
		 * @param $data
		 */
		function ConvertIcoToImage($data)
		{
			// imagecreatefromstring did not work for ico
			// found class on http://www.tom-reitz.com/2009/02/09/ico-images-in-facebook-profile-boxes/
			$image='';
			$icon = new Ico();
			if(!($icon->LoadData($data)))
			{
				EdlUtils::favicon_page_msg('','[PNG_CONVERSION] could not load the ico...');
			}
			else
			{
				EdlUtils::favicon_page_msg('','[PNG_CONVERSION] loaded the ico...');
			}
			if(!($image=$icon->GetIcon(0)))
			{
				EdlUtils::favicon_page_msg('','[PNG_CONVERSION] could not get ico data from ico...');
			}
			else
			{
				EdlUtils::favicon_page_msg('','[PNG_CONVERSION] got image from ico...');
			}
			return $image;
		}

		/**
		 * Make an PNG from an image
		 * lots of nice info on http://php.net/manual/en/function.imagepng.php
		 * Enter description here ...
		 * @param $image
		 */
		function GetConvertedPNGImage($image)
		{
			ob_start();
			imagealphablending($image, true); // setting alpha blending on
			imagesavealpha($image, true); // save alphablending setting (important)
			imagepng($image, NULL, 0, NULL);
			$image_png = ob_get_contents();
			ob_end_clean();
			return $image_png;
		}

		/**
		 * Adds the png converter functionality
		 */
		function AddFilter()
		{
			add_filter('wp_favicons_convert', array($this,'ExecuteFilter'), 6, 2);
		}

		/**
		 * Executes the functionality of the png converter
		 * @param $favicon_array
		 */
		function ExecuteFilter( /*array*/ $favicon_array )
		{

			if (!$favicon_array) {return $favicon_array;}

			/* png is easy */
			if ('png' == $favicon_array['type'])
			{
				EdlUtils::favicon_page_msg('',
						'[PNG_CONVERSION] already png');

			}
			/* ico needs a seperate lib */
			if ('ico' == $favicon_array['type'])
			{
				EdlUtils::favicon_page_msg('',
						'[PNG_CONVERSION] ico to png');
				$image='';
				$image = $this->ConvertIcoToImage($favicon_array['data']);
				$image = $this->GetConvertedPNGImage($image);
				$favicon_array['data'] = $image;
				$favicon_array['type'] = 'png';
				Database::UpdateFaviconFoundWithFilter('PNG', $favicon_array['id'] ,' converted ICO to PNG', 'png');
				return $favicon_array;
			}
			/* everything else should be possible */
			else
			{
				$image = '';
				$image = @imagecreatefromstring($favicon_array['data']);
				if ( !is_resource( $image ) )
				{
					// This is a (Costly) beta double check!
					EdlUtils::favicon_page_msg('','[PNG_CONVERSION] : this is not an image! :' . $filetype2);
					$favicon_array='';
					return $favicon_array;
				}
				else
				{
					$image = $this->GetConvertedPNGImage($image);
					$favicon_array['data'] = $image;
					Database::UpdateFaviconFoundWithFilter('PNG', $favicon_array['id'] ,' converted ' . $favicon_array['type'] . ' to PNG', 'png');
					$favicon_array['type'] = 'png';
					return $favicon_array;
				}
			}
			EdlUtils::favicon_page_msg('','[PNG_CONVERSION] something went wrong!');
			return $favicon_array;
		}
	}
}