<?php
/**
 * Filter to Extract a favicon from the root of a domain
 *
 * This file contains the wp_favicons_search filter implementation
 * to get a favicon.ico from the root of a domain
 *
 * Note: feel free to add your own filters!
 *
 * @package WP-Favicons
 * @since 0.4.0
 * @author Edward de Leau <e@leau.net>
 * @copyright Edward de Leau, http://edward.de.leau.net
 */

namespace leau\co\wp_favicons;

/**
 *
 * Enter description here ...
 * @param unknown_type $favicon_array
 * @param unknown_type $url
 */
if (!class_exists("sources_root"))
{
	class sources_root extends Plugin
	{
		public $_data_url = '';

	 	/**
    	 * (non-PHPdoc)
    	 * @see plugins/EdlLinkFaviconPlugin::AddFilter()
    	 */
    	function AddFilter()
    	{
    		/* parent class arranges that this is not called when the bool is off */
    		add_filter(Config::GetPluginSlug() . 'search', array($this,'DoFilter'), 6, 2);
    	}

		/**
		 *
		 * Enter description here ...
		 * @param $favicon_array
		 * @param $url
		 */
		function DoFilter( /*array*/ $favicon_array, /*string*/ $url)
		{
			$data_url = $this->DataUrl($url);
			/* the following three lines should always be the executed */
			if (!$data = EdlUtils::favicon_filter_init($favicon_array, $data_url)) { return $favicon_array; }
			/* check that data is an image */
			$favicon_array['data'] = $data;
			$favicon_array = EdlUtils::VerifyImage($favicon_array);
			/* @todo 0.5.0 add more redirection support */

			$id = Database::LogFaviconFound(array(
				 			'uri' => $url,
							'type' => $favicon_array['type'],
							'filetypesure' => false,
							'data' => $data,
							'default' => false,
							'comment' => $url,
							'source'=> 'root'));
			$favicon_array['id'] = $id;
			EdlUtils::favicon_page_msg($url,' [IN_ROOT] FOUND !');

			return $favicon_array;
		}

    	/**
    	 * (non-PHPdoc)
    	 * @see plugins/search/inc/EdlLinkFaviconPluginSources::DataUrl()
    	 */
    	function DataUrl($url)
    	{
    		$this->_data_url = 'http://' . parse_url($url,PHP_URL_HOST) . '/favicon.ico';
			return $this->_data_url;
    	}

	}
}